import { descriptor } from "./descriptor";
import { fromJSONThink } from "./fromJSONThink";
import { obj } from "./obj";
import { toJSONThink } from "./toJSONThink";
import { toJSONThinkWithVal } from "./toJSONThinkWithVal";
export declare const withToJSONThink: (value: any) => value is obj<{
    toJSONThink: toJSONThink;
}>;
export declare const withToJSONThinkWithValue: (value: any) => value is obj<{
    toJSONThink: toJSONThinkWithVal;
}>;
export declare const withFromJSONThink: (value: any) => value is obj<{
    fromJSONThink: fromJSONThink;
}>;
export declare const isObjectKeyType: <K extends string = "$$type">(value: any, propTypeName?: K) => value is obj<{ [k in K]: string; }>;
export declare const isTransformDescription: (value: any) => value is obj<descriptor<any, any>>;
export declare class JSONThink<K extends string = "$$type"> {
    private options?;
    constructor(options?: {
        propTypeName?: K | undefined;
    } | undefined);
    readonly propTypeName: string | NonNullable<K>;
    private listThinks;
    private listThinksByName;
    private listThinksDescriptions;
    use(ref: any, name?: string): this;
    stringify(value: any, replacer?: (this: any, key: string, value: any) => any, space?: string | number): string;
    private deep;
    replacerLow: (replacer?: ((this: any, key: string, value: any) => any) | undefined) => (key: string, value: any) => any;
    parse(text: string, reviver?: (this: any, key: string, value: any) => any): any;
}
export declare const jsonThink: JSONThink<"$$type">;
